Program wtchdehk;
Uses CRT, DOS;

Const
  GamesCount = 6;

Type
  TPatchList = Packed Record
    Offset: Array[1..GamesCount] Of Longint; { file offset }
    Values: Array[0..1] Of Byte; { old_byte, new_byte }
  End;

  TGameList = Packed Record
    Name: String[7];  { filename }
    Game: String[29]; { gamename }
    Size: Longint;    { filesize }
  End;

  TPatches = Packed Record
    Info: String[31];       { patch description }
    Idx, Count, Stat: Byte; { index, count, state }
  End;

Const
  GameList: Array[1..GamesCount] Of TGameList = (
    (Name: 'WH.EXE'; Game: 'Witchaven from retail CD 1.0'; Size: 675280), { 1995.09.04 00:34:18 }
    (Name: 'WH.EXE'; Game: 'Witchaven Cheat Patch 1.0';    Size: 696011), { 1995.10.12 17:49:36 }
    (Name: 'WH.EXE'; Game: 'Witchaven Updates 1.1';        Size: 621249), { 1995.11.08 15:21:00 }
    (Name: 'WH.EXE'; Game: 'Witchaven VFX1 Headgear 1.1';  Size: 708021), { 1996.01.09 10:09:30 }
    (Name: 'WH.EXE'; Game: 'Witchaven for Dwango 1.1';     Size: 775163), { 1996.01.12 11:25:10 }
    (Name: 'WH.EXE'; Game: 'Witchaven from sources 1.1';   Size: 765149)  { 1996.03.05 10:19:38 }
  );
  PatchesCount = 6;
  Patches: Array[1..PatchesCount] Of TPatches = (
    (Info: 'Disable MSCDEX check (nocd)';    Idx:  1; Count: 1; Stat: 0),
    (Info: 'Revert [Mouselook] logic';       Idx:  2; Count: 1; Stat: 0),
    (Info: 'Increase mouse vertical speed';  Idx:  3; Count: 1; Stat: 0),
    (Info: 'Invert mouse on vertical axis';  Idx:  4; Count: 2; Stat: 0),
    (Info: 'Revert [Run] logic';             Idx:  6; Count: 2; Stat: 0),
    (Info: 'Increase horizontal turn speed'; Idx:  8; Count: 1; Stat: 0)
  );
  PatchByte = 8;
  PatchList: Array[1..PatchByte] Of TPatchList = (
    { disable cd-rom check (!! Program abnormally terminated !! -> CD-ROM NOT DETECTED) }
    (Offset: ($0002B7CE, $0002BE77, $00000000, $0002C682, $0002DA82, $00000000); Values: ($74, $EB)),
    { revert [mouselook] logic (always mouselook) }
    (Offset: ($0003E332, $0003EAB7, $0003FA7A, $0004009D, $0004149D, $00041B81); Values: ($74, $75)),
    { increase mouse vertical speed }
    (Offset: ($0003E346, $0003EACB, $0003FA8E, $000400B1, $000414B1, $00041B95); Values: ($04, $02)),
    { invert mouse on vertical axis }
    (Offset: ($0003E347, $0003EACC, $0003FA8F, $000400B2, $000414B2, $00041B96); Values: ($01, $2B)),
    (Offset: ($0003E348, $0003EACD, $0003FA90, $000400B3, $000414B3, $00041B97); Values: ($C2, $D0)),
    { revert [run] logic (always run) }
    (Offset: ($0003E5ED, $0003EE7A, $0003FE45, $00040618, $00041A18, $0004206C); Values: ($75, $74)),
    (Offset: ($0003F0A1, $0003F934, $000408F9, $000410CC, $000424CC, $00042B34); Values: ($76, $77)),
    { increase horizontal turn speed }
    (Offset: ($0003F4C4, $0003FD57, $00040D1C, $000414EE, $000428EE, $00042F57); Values: ($04, $02))
  );

Function FileExists(FileName: String; FileSize: Longint): Boolean;
Var DirInfo: SearchRec;
Begin
  FindFirst(FileName, ReadOnly + Hidden + SysFile + Archive, DirInfo);
  FileExists:=((DOSError = 0) And (DirInfo.Size = FileSize));
End;

Function ReadKeyEx: Word;
Var Res: Word;
Begin
  While KeyPressed Do ReadKey;
  Res:=Ord(ReadKey);
  If Res = 0 Then Res:=Word(Ord(ReadKey)) ShL 8;
  While KeyPressed Do ReadKey;
  ReadKeyEx:=Res;
End;

Procedure ShowMsgInfo(MsgStr: String);
Begin
  WriteLn(MsgStr);
  WriteLn('Press any key to exit.');
  ReadKeyEx;
End;

Procedure DrawHeader;
Begin
  ClrScr;
  WriteLn('Witchaven DeHacker v1.0');
  WriteLn('(c) -=CHE@TER=- 2015');
  WriteLn('e-mail: _CTPAX_@MAIL.RU');
  WriteLn('http://CTPAX-CHEATER.losthost.org');
  WriteLn;
  WriteLn('(c) Corak the Avatar 2015');
  WriteLn('e-mail: corakdoom@mail.ru');
  WriteLn;
End;

Var
     Fl: File;
  FAttr: Word;
  FTime: Longint;
   B, I, Idx: Integer;
      X: Byte;
Begin
  DrawHeader;
  B:=0;
  For I:=1 To GamesCount Do
  Begin
    If FileExists(GameList[I].Name, GameList[I].Size) = True Then
    Begin
      B:=B Or (1 ShL (I - 1));
      WriteLn('[', I, '] ', GameList[I].Game);
    End;
  End;
  If B = 0 Then
  Begin
    ShowMsgInfo('ERROR: no game executables found! Run this program from the game folder.');
    Exit;
  End;
  Write('Select number of the game to patch (ESC - exit): ');
  Idx:=0;
  Repeat
    Idx:=ReadKeyEx;
    If Idx = 27 Then { ESC }
    Begin
      Idx:=0;
      Break;
    End;
    { only digits from 1 to 9 }
    If ((Idx > 48) And (Idx <= 48 + GamesCount)) Then Idx:=Idx - 48
    Else Idx:=0;
    { filter missing executables }
    If (B And (1 ShL (Idx - 1))) = 0 Then Idx:=0;
  Until Idx <> 0;
  If Idx = 0 Then
  Begin
    WriteLn('[exit]');
    Exit;
  End;
  WriteLn(GameList[Idx].Game);
  Assign(Fl, GameList[Idx].Name);
  GetFAttr(Fl, FAttr);
  SetFAttr(Fl, Archive);
  {$I-}
  Reset(Fl, 1);
  {$I+}
  If IOResult <> 0 Then
  Begin
    ShowMsgInfo('ERROR: can''t open file "' + GameList[Idx].Name + '" for write!');
    Exit;
  End;
  GetFTime(Fl, FTime);
  For I:=1 To PatchesCount Do
  Begin
    { if offset = 0 - skip this byte }
    If PatchList[Patches[I].Idx].Offset[Idx] <> 0 Then
    Begin
      Seek(Fl, PatchList[Patches[I].Idx].Offset[Idx]);
      BlockRead(Fl, X, 1);
      { lazy check - only first byte in sequence for patch }
      Patches[I].Stat:=Ord(X <> PatchList[Patches[I].Idx].Values[0]); { patched? }
    End;
  End;

  Repeat
    DrawHeader;
    WriteLn('List of available patches for [', GameList[Idx].Game, ']:');
    WriteLn;
    For I:=1 To PatchesCount Do
      WriteLn('[', I,'] [', Chr(32 + Patches[I].Stat) ,'] ', Patches[I].Info);
    WriteLn;
    WriteLn('Press 1..', PatchesCount, ' for enable [!] or disable [ ] patches.');
    WriteLn('ENTER - save changes; ESC - exit without saving.');
    B:=ReadKeyEx;
    If ((B > 48) And (B <= 48 + PatchesCount)) Then
    Begin
      B:=B - 48;
      Patches[B].Stat:=(Patches[B].Stat + 1) And 1; { 0/1 }
      B:=0;
    End;
  Until (B = 13) Or (B = 27); { Enter or ESC }
  WriteLn;
  { Enter - apply patches }
  If B = 13 Then
  Begin
    Write('Exit and save changes.');
    For I:=1 To PatchesCount Do
    Begin
      For B:=1 To Patches[I].Count Do
      Begin
        { if offset = 0 - skip this byte }
        If PatchList[Patches[I].Idx + B - 1].Offset[Idx] <> 0 Then
        Begin
          Seek(Fl, PatchList[Patches[I].Idx + B - 1].Offset[Idx]);
          BlockWrite(Fl, PatchList[Patches[I].Idx + B - 1].Values[Patches[I].Stat], 1);
        End;
      End;
    End;
  End
  Else
    Write('Exit without saving.');
  SetFTime(Fl, FTime);
  Close(Fl);
  SetFAttr(Fl, FAttr);
  ShowMsgInfo('');
End.
